{

rtrack template engine
(c) 1999-2000 by raVen

supported compilers: borland pascal 7.x, virtual pascal 2.0+

}
{&Use32+,LocInfo+}
{$D+,L+,I-,R-,S-,Q-,B-}
{}
Unit rTpl;
interface
Uses Objects, rMacroz, rAbs;
{}
type
{( tTemplate )}
 pTemplate = ^tTemplate;
 tTemplate = object(tObject)
  Macros: pMacros;
  constructor Init;
  destructor  Done; virtual;
  procedure   AddStringMacro(aFindStr,aReplStr: String; CaseSens: Boolean);
  procedure   ProcessStream(var Stream: tStream); virtual;
  procedure   AddForwardMacros(var SourceMsg, DestinationMsg: tAbsMsg);
  procedure   ForwardMsg(var SourceMsg, DestinationMsg: tAbsMsg; var Template: tStream);
 end;
{}
implementation
Uses rObjects, rStrings, rAsciiz, Strings, rCommon, rTime, Dos;
{( tTemplate )}
constructor tTemplate.Init;
 begin
  New(Macros,Init);
 end;
{}
destructor tTemplate.Done;
 begin
  DisposeObj(Macros);
 end;
{}
procedure tTemplate.AddStringMacro;
 begin
  Macros^.AddStringMacro(aFindStr,aReplStr,CaseSens);
 end;
{}
const
 mInsertFile: pChar = '@InsertFile{';
 nst: pStream = nil;
 cm: pAbsMsg = nil;
 sm: pAbsMsg = nil;
procedure tTemplate.ProcessStream;
 var
  a: pChar;
  x,l: Word;
  zz: Longint;
  s: String;
 begin
  if (@Stream=nil) then exit;
  if (Stream.GetSize=0) then exit;
  Stream.Seek(0);
  nst:=New(pMemoryStream,Init(0,BlockSize));
  a:=nil;
  repeat
   StreamReadLnAsc(Stream,a);
   l:=PosStr(CommaPoint,a);
   if (l<>AscNotFound) then DeleteAsc(a,l,AscNotFound);
   if (l=0) then Continue;
   Macros^.ProcessAsciiz(a);
   StreamWritelnAsc(nst^,a,cr+lf);
  until (Stream.GetSize=Stream.GetPos) or (Stream.Status<>0);
  nst^.Seek(0);
  Stream.Seek(0);
  Stream.CopyFrom(nst^,nst^.GetSize);
  Stream.Truncate;
  DisposeObj(nst);
  StrFree(a);
 end;
{}
procedure PrsMsgAttributes(var s: String; const macros: pMacros);
 var
  x,c: Integer;
  s1: String;
 begin
  if (cm=nil) then exit;
  c:=WordCount(s,PrsSet);
  for x:=1 to c do with cm^.cFlags do
   begin
    s1:=UpStr(ExtractWord(x,s,PrsSet))+Space;
    if (s1=UpStr(tflPVT)) then PVT:=true else
    if (s1=UpStr(tflCRA)) then CRA:=true else
    if (s1=UpStr(tflRCV)) then RCV:=true else
    if (s1=UpStr(tflSNT)) then SNT:=true else
    if (s1=UpStr(tflATT)) then ATT:=true else
    if (s1=UpStr(tflTRS)) then TRS:=true else
    if (s1=UpStr(tflORP)) then ORP:=true else
    if (s1=UpStr(tflK_S)) then K_S:=true else
    if (s1=UpStr(tflLOC)) then LOC:=true else
    if (s1=UpStr(tflHLD)) then HLD:=true else
    if (s1=UpStr(tflFRQ)) then FRQ:=true else
    if (s1=UpStr(tflRRQ)) then RRQ:=true else
    if (s1=UpStr(tflRRC)) then RRC:=true else
    if (s1=UpStr(tflARQ)) then ARQ:=true else
    if (s1=UpStr(tflURQ)) then URQ:=true else
    if (s1=UpStr(tflA_S)) then A_S:=true else
    if (s1=UpStr(tflDIR)) then DIR:=true else
    if (s1=UpStr(tflZON)) then ZON:=true else
    if (s1=UpStr(tflHUB)) then HUB:=true else
    if (s1=UpStr(tflIMM)) then IMM:=true else
    if (s1=UpStr(tflXMA)) then XMA:=true else
    if (s1=UpStr(tflKFS)) then KFS:=true else
    if (s1=UpStr(tflTFS)) then TFS:=true else
    if (s1=UpStr(tflLOK)) then LOK:=true else
    if (s1=UpStr(tflCFM)) then CFM:=true;
   end;
  s:='';
 end;
{}
procedure PrsMsgSetFromName(var s: String; const macros: pMacros);
 begin
  if (cm=nil) then exit;
  cm^.SetSourceName(s);
  s:='';
 end;
{}
procedure PrsMsgSetFromAddr(var s: String; const macros: pMacros);
 begin
  if (cm=nil) then exit;
  cm^.SetSourceAddress(s);
  s:='';
 end;
{}
procedure PrsMsgSetToName(var s: String; const macros: pMacros);
 begin
  if (cm=nil) then exit;
  cm^.SetDestinationName(s);
  s:='';
 end;
{}
procedure PrsMsgSetToAddr(var s: String; const macros: pMacros);
 begin
  if (cm=nil) then exit;
  cm^.SetDestinationAddress(s);
  s:='';
 end;
{}
procedure PrsMsgSetSubject(var s: String; const macros: pMacros);
 begin
  if (cm=nil) then exit;
  cm^.SetSubject(s);
  s:='';
 end;
{}
procedure PrsMsgInsertFile(var s: String; const macros: pMacros);
 var
  f: pStream;
  a: pChar;
  eof: Boolean;
 begin
  if (nst=nil) then exit;
  if not Exist(s) then StreamWriteLn(nst^,'['+s+'] is not found!',cr+lf) else
   begin
    a:=nil;
    f:=New(pBufStream,Init(s,stOpenRead or stDenyWrite,BlockSize));
    repeat
     StreamReadLnAsc(f^,a);
     Macros^.ProcessAsciiz(a);
     eof:=(f^.GetSize=f^.GetPos) or (f^.Status<>0);
     if (eof) then StreamWriteLnAsc(nst^,a,'') else StreamWriteLnAsc(nst^,a,cr+lf);
    until (eof);
    DisposeObj(f);
    StrFree(a);
   end;
  s:='';
 end;
{}
procedure PrsMsgMessage(var s: String; const macros: pMacros);
 var
  SkipKludges,SkipBody,SkipUUE: Boolean;
  s1: String;
  wc,x: Integer;
  a: pChar;
  eof: Boolean;
 begin
  if (sm=nil) or (nst=nil) then exit;

  SkipKludges:=False;
  SkipBody:=False;
  SkipUUE:=False;
  wc:=WordCount(s,['|']);
  for x:=1 to wc do if (UpStr(ExtractWord(x,s,['|']))='SKIPKLUDGES') then SkipKludges:=True
                    else if (UpStr(ExtractWord(x,s,['|']))='SKIPBODY') then SkipBody:=True
                    else if (UpStr(ExtractWord(x,s,['|']))='SKIPUUE') then SkipUUE:=True;

  s:='';
  a:=nil;

  with (sm^) do
   begin
    if (not SkipKludges) then with (AbsMsgData) do
     begin
      if (GetPS(Area)='') then
       begin
        if (OrigPoint<>0) then
         begin
          s:=klFMPT+NToC(OrigPoint);
          Macros^.ProcessString(s);
          StreamWriteLn(nst^,s,cr+lf);
         end;
        if (DestPoint<>0) then
         begin
          s:=klTOPT+NToC(DestPoint);
          Macros^.ProcessString(s);
          StreamWriteLn(nst^,s,cr+lf);
         end;
        if (GetPS(INTL)<>'') then
         begin
          s:=klINTL+GetPS(INTL);
          Macros^.ProcessString(s);
          StreamWriteLn(nst^,s,cr+lf);
         end;
       end;
      if (GetPS(MsgID)<>'') then
       begin
        s:=klMsgID+GetPS(MsgID);
        Macros^.ProcessString(s);
        StreamWriteLn(nst^,s,cr+lf);
       end;
      if (GetPS(Reply)<>'') then
       begin
        s:=klReply+GetPS(Reply);
        Macros^.ProcessString(s);
        StreamWriteLn(nst^,s,cr+lf);
       end;
      if (GetPS(Flags)<>'') then
       begin
        s:=klFlags+GetPS(Flags);
        Macros^.ProcessString(s);
        StreamWriteLn(nst^,s,cr+lf);
       end;
      if (GetPS(PID)<>'') then
       begin
        s:=klPID+GetPS(PID);
        Macros^.ProcessString(s);
        StreamWriteLn(nst^,s,cr+lf);
       end;
      if (GetPS(TID)<>'') then
       begin
        s:=klTID+GetPS(TID);
        Macros^.ProcessString(s);
        StreamWriteLn(nst^,s,cr+lf);
       end;
      if (OtherCol^.Count>0) then for x:=0 to OtherCol^.Count-1 do
       begin
        s:=GetPS(OtherCol^.At(x));
        Macros^.ProcessString(s);
        StreamWriteLn(nst^,s,cr+lf);
       end;
     end;
    MsgBody^.Seek(0);

    if (not SkipBody) then
    repeat
     StreamReadLnAsc(MsgBody^,a);
     Macros^.ProcessAsciiz(a);
     eof:=(MsgBody^.GetSize=MsgBody^.GetPos) or (MsgBody^.Status<>0);
     if ((SkipKludges) and (eof and (GetPS(AbsMsgData.TearLine)='') and
         (GetPS(AbsMsgData.Origin)='') and (ViaCol^.Count<=0))) then
     StreamWriteLnAsc(nst^,a,'')
     else StreamWriteLnAsc(nst^,a,cr+lf);
    until (eof);

    with (AbsMsgData) do
     begin
      if (GetPS(TearLine)<>'') then
       begin
        s:=bTearLine+GetPS(TearLine);
        Macros^.ProcessString(s);
        if ((SkipKludges) and (GetPS(Origin)='') and (ViaCol^.Count<=0)) then StreamWriteLn(nst^,s,'') else
        StreamWriteLn(nst^,s,cr+lf);
       end;
      if (GetPS(Origin)<>'') or (GetPS(Area)<>'') then
       begin
        s:=bOrigin+GetPS(Origin)+Bracket1+GetSourceAddress+Bracket2;
        Macros^.ProcessString(s);
        if ((SkipKludges) or (ViaCol^.Count<=0)) then StreamWriteLn(nst^,s,'') else StreamWriteLn(nst^,s,cr+lf);
       end;
     end;

    if (not SkipKludges) and (ViaCol^.Count>0) then for x:=0 to ViaCol^.Count-1 do
     begin
      s:=GetPS(ViaCol^.At(x));
      Macros^.ProcessString(s);
      if (x=ViaCol^.Count-1) then StreamWriteLn(nst^,s,'') else StreamWriteLn(nst^,s,cr+lf);
     end;
   end;
  if (SkipUUE) then
   begin
    s:='@AppName';
    Macros^.ProcessString(s);
    nst^.Seek(0);
    rStrings.SkipUUE(nst^,s);
    nst^.Seek(nst^.GetSize);
   end;
  StrFree(a);
  s:='';
 end;
{}
procedure tTemplate.AddForwardMacros;
 var
  s: String;
  dt: DateTime;
 begin
  cm:=@DestinationMsg;
  sm:=@SourceMsg;
  nst:=DestinationMsg.MsgBody;
  with (Macros^) do
   begin
    AddStringMacro(#1,Masyamba,True);
    AddStringMacro('@:)',#1,True);
    AddStringMacro('','H',True);

    AddNewPrs('@SetAttributes',PrsMsgAttributes);
    AddNewPrs('@SetFromName',PrsMsgSetFromName);
    AddNewPrs('@SetFromAddr',PrsMsgSetFromAddr);
    AddNewPrs('@SetToName',PrsMsgSetToName);
    AddNewPrs('@SetToAddr',PrsMsgSetToAddr);
    AddNewPrs('@SetSubject',PrsMsgSetSubject);
    AddNewPrs('@InsertFile',PrsMsgInsertFile);
    AddNewPrs('@Message',PrsMsgMessage);
   end;

  with (SourceMsg) do
   begin
    AddStringMacro('@SourceName',GetSourceName,False);
    AddStringMacro('@SourceAddress',GetSourceAddress,False);
    AddStringMacro('@DestinationName',GetDestinationName,False);
    AddStringMacro('@DestinationAddress',GetDestinationAddress,False);
    AddStringMacro('@Subject',GetSubject,False);
    GetCurrentTime(dt);
    AddStringMacro('@cTimeStr',TimeStr(dt),False);
    AddStringMacro('@cDateStr',DateStr(dt),False);
    AddStringMacro('@SourceDate',GetFscTime(AbsMsgData.DateWritten),False);
    AddStringMacro('@MsgSize',NToC(MsgBody^.GetSize),False);
    with (SourceMsg) do
     begin
      AddStringMacro('@daddr',GetDestinationAddress,false);
      s:=GetDestinationName;
      AddStringmacro('@dfname',ExtractWord(1,s,SpaceChars),false);
      AddStringMacro('@dlname',ExtractWord(WordCount(s,SpaceChars),s,SpaceChars),false);
      AddStringMacro('@dname',s,false);
      AddStringmacro('@tfname',ExtractWord(1,s,SpaceChars),false);
      AddStringMacro('@tlname',ExtractWord(WordCount(s,SpaceChars),s,SpaceChars),false);
      AddStringMacro('@tname',s,false);
      s:=GetSourceName;
      AddStringmacro('@ofname',ExtractWord(1,s,SpaceChars),false);
      AddStringMacro('@olname',ExtractWord(WordCount(s,SpaceChars),s,SpaceChars),false);
      AddStringMacro('@oname',s,false);

      AddStringMacro('@oTimeStr',TimeStr(AbsMsgData.DateWritten),False);
      AddStringMacro('@oDateStr',DateStr(AbsMsgData.DateWritten),False);
      with (AbsMsgData.DateWritten) do
       begin
        AddStringMacro('@oSec',NToC(Sec),false);
        AddStringMacro('@oMin',NToC(Min),false);
        AddStringMacro('@oHour',NToC(Hour),false);
        AddStringMacro('@oDay',NToC(Day),false);
        AddStringMacro('@oMonth',NToC(Month),false);
        AddStringMacro('@oYear',NToC(Year),false);
        AddStringMacro('@oTextMonth',MonthNameSE[Month],false);
       end;
     end;

    s:=GetAttributesLine;
    if s='' then s:='+++';
    AddStringMacro('@Attributes',s,False);
   end;
 end;
{}
procedure tTemplate.ForwardMsg;
 var
  p: Word;
  a,a1: pChar;
  s: String;
  pnst,pcm,psm: Pointer;
 begin
  if (@SourceMsg=nil) or (@DestinationMsg=nil) or (@Template=nil) then exit;
  if (Template.GetSize=0) then exit;
  Template.Seek(0);
  DestinationMsg.MsgBody^.CopyFrom(Template,Template.GetSize);

  AddForwardMacros(SourceMsg,DestinationMsg);

  pnst:=nst;
  pcm:=cm;
  psm:=sm;

  with (DestinationMsg) do
   begin
    UnPackTime(GetCurrentDosTime,AbsMsgData.DateWritten);
   end;

  ProcessStream(DestinationMsg.MsgBody^);

  nst:=pnst;
  cm:=pcm;
  sm:=psm;
 end;

end.
